/* ᬠਢ  
   1) 窠  ,
   2) 窠   אַ  0,
      塞 ᪮, ।塞  㦥
       㦭 ⪥ ࠤ
   3) 窠   0, 㥬 , 
      饬  祭   窨
   뢠,   ᫥  (eps)
*/
#include <stdio.h>
#include <math.h>
double a1,d1,a2,d2;
double a3[10],d3[10],t;
double eps=1e-9;
int nres,i,j;
double tograd(double a)
{ a=90-a*180/M_PI;
  while(a<0) a+=360;
  while(a>=360) a-=360;
  if(fabs(a)<eps) a=0;
  if(fabs(360-a)<eps) a=0;
  return a;
}
int between(double a, double a1, double a2)
{ /* a1<a2 0<=a2<360 */
  return a<=a2 && a1<=a || a+360<=a2 && a1<=a+360 || a-360<=a2 && a1<=a-360;
}
int cross(double x1, double  y1, double x2, double  y2, double tm,
     double t1, double t2, double dt, double *x3, double *y3)
{ double t,ar,x,y,a,ap,arp;
  for(t=t1;t<t2;t+=dt)
  {
    ar=tograd((90-a1-t*180)/180*M_PI);
    x=x1+(x2-x1)*t/tm;
    y=y1+(y2-y1)*t/tm;
    if(sqrt(x*x+y*y)<0.0001) continue;
    a=tograd(atan2(y,x));
    if(fabs(ar-a)<=eps)
    { *x3=x;
      *y3=y;
      return 1;
    }
    if(t>t1)
    {
      if(ar<arp)
        arp-=360;
      if(fabs(a-ap)>180-eps)
      { if(a-ap>180-eps)
          ap+=360;
        else
          ap-=360;
      }
      if(a>ap && between(a,arp,ar) && between(ap,arp,ap) ||
         a<ap && between(ap,arp,ar))
      {
        if(dt<0.000001)
        {
          *x3=x;
          *y3=y;
          return 1;
        }
        if(cross(x1,y1,x2,y2,tm,t-dt,t,dt*0.01,x3,y3))
          return 1;
      }
    }
    ap=a;
    arp=ar;
  }
  return 0;
}
void addpoint(double x3, double y3)
{
  a3[nres]=tograd(atan2(y3,x3));
  d3[nres]=sqrt(x3*x3+y3*y3);
  nres++;
}
void check(int nc)
{
  double t,x1,y1,x2,y2,x3,y3;
  double ar,tm;
  int flg=0;
  ar=(90-a1)/180*M_PI;
  x1=d1*cos(ar);
  y1=d1*sin(ar);
  ar=(90-a2)/180*M_PI;
  x2=d2*cos(ar);
  y2=d2*sin(ar);
  if(a1<a2) tm=(a2-a1)/180+2*nc;
  else tm=(a2+360-a1)/180+2*nc;
  /* אַ  業 */
  if(fabs(x2-x1)<=eps && fabs(x1)<=eps)
  { flg=1;
    t=y1*tm/(y1-y2);
  }
  else if(fabs(x2-x1)>eps)
  { 
    t=x1*tm/(x1-x2);
    if(fabs(y1+(y2-y1)*t/tm)<=eps)
      flg=1;
  }
  if(flg)
  {
    if(t<=eps || t>4+eps)
    {
      if(fabs(tm-2)<=eps)
      { addpoint(x1+(x2-x1)*4/tm,y1+(y2-y1)*4/tm);
      }
    } 
    else if(fabs(t-4)<=eps)
    {
      if(fabs(tm-2)<=eps)
      { addpoint(x1+(x2-x1)*6/tm,y1+(y2-y1)*6/tm);
      }
    }
    else if(fabs(t-2)<=eps)
    {
      if(fabs(tm-4)<=eps)
      { addpoint(x1+(x2-x1)*6/tm,y1+(y2-y1)*6/tm);
      }
    }
    else if(fabs(t-1)<=eps)
    {
      if(fabs(tm-3)<=eps)
      { addpoint(x1+(x2-x1)*5/tm,y1+(y2-y1)*5/tm);
      }
    }
    else if(t<1)
    {
      if(fabs(tm-1)<=eps)
      { addpoint(x1+(x2-x1)*3/tm,y1+(y2-y1)*3/tm);
      }
    }
    else if(t<2)
    {
      if(fabs(tm-3)<=eps)
      { addpoint(x1+(x2-x1)*5/tm,y1+(y2-y1)*5/tm);
      }
    }
    else if(t<3)
    {
      if(fabs(tm-2)<=eps)
      { addpoint(x1+(x2-x1)*3/tm,y1+(y2-y1)*3/tm);
      }
    }
    else
    {
      if(fabs(tm-2)<=eps)
      { addpoint(x1+(x2-x1)*5/tm,y1+(y2-y1)*5/tm);
      }
    }
    return;
  }
  /*  業 */
  if(cross(x1,y1,x2,y2,tm,0.001,tm-0.001,0.01,&x3,&y3)) return;
  if(cross(x1,y1,x2,y2,tm,tm+0.001,tm+4.001,0.01,&x3,&y3))
  {
    addpoint(x3,y3);
  }
}
int main()
{
  FILE *f1,*f2;
  f1=fopen("input.txt","r");
  f2=fopen("output.txt","w");
  while(fscanf(f1,"%lf%lf%lf%lf",&a1,&d1,&a2,&d2)==4)
  { nres=0;
    if(fabs(a1-a2)<=eps && fabs(d1-d2)<=eps) /* 窠 ⮨   */
    {
      a3[nres]=a1;
      d3[nres]=d1;
      nres++;
    }
    else
    {
      check(0);
      check(1);
    }
    /* ஢ */
    for(i=0;i<nres-1;i++)
      for(j=i+1;j<nres;j++)
        if(a3[i]>a3[j] || a3[i]==a3[j] && d3[i]<d3[j])
        { t=a3[i];a3[i]=a3[j];a3[j]=t;
          t=d3[i];d3[i]=d3[j];d3[j]=t;
        }
    for(i=0;i<nres;i++)
      fprintf(f2,"%.2lf %.2lf%c",a3[i],d3[i],(i<nres-1)?' ':'\n');
    if(nres==0) fprintf(f2,"error\n");
  }
  fclose(f1);
  fclose(f2);
}
